Whamcloud - gitweb
Try to avoid a race where two rpmbuilds on the same node are trying to stage
[fs/lustre-release.git] / lustrecvs
index 433c616..78db90e 100755 (executable)
--- a/lustrecvs
+++ b/lustrecvs
@@ -1,5 +1,6 @@
 #!/bin/sh
 
+LC_COLLATE="C"
 progname="${0##*/}"
 
 warn ()
@@ -18,16 +19,31 @@ fatal ()
 usage ()
 {
     cat <<EOF
-Usage: $progname lustretag
-  where lustretag is a tag of the lustre-core module
+Usage: $progname <lustretag>
+  where <lustretag> is a tag of the lustre-core module
 EOF
 }
 
-# portalstag="HEAD"
-portalstag="b1_4"
+if [ -z "$LUSTRECVS_UPDATED" ] ; then
+    echo "$progname: updating lustrecvs"
+    cvs up -l || fatal 1 "Error updating lustrecvs"
+    export LUSTRECVS_UPDATED=yes
+    exec "$0" "$@"
+fi
+
+[ "$1" = "-r" ] && shift
+
 buildtag="HEAD"
+lustretag="$1"
+shift
+
+if [ "$*" ] ; then
+    usage >&2
+    exit 1
+fi
+
 
-case "$1" in
+case "$lustretag" in
     '')
         warn "a lustretag is required."
        usage >&2
@@ -38,30 +54,68 @@ case "$1" in
        exit 0
        ;;
 
+    # These releases did not get build tagged for them because they
+    # this build system didn't exist when they were tagged
+    v1_2_8|v1_4_0) 
+        buildtag="b1_4"
+        ;;
+    
+    b1_4*) buildtag="b1_4" ;;
+
+    b_release_1_4_6-patchless) buildtag="b1_4" ;;
+    b_release_1_4_7-test) buildtag="b_release_1_4_7" ;;
+
+    v* | b_release*) buildtag=$lustretag ;;
+
     # this is the branch table
     # keep this list sorted alphabetically!
 
-    b1_4_bgl)
-       portalstag="b1_4_bgl"
+    *)
+        buildtag="HEAD"
        ;;
 
 esac
 
+error_modules=
 cvs_cmd ()
 {
-    local dir="$1"
-    local module="$2"
-    local tag="$3"
+    dir="$1"
+    module="$2"
+    tag="$3"
+    cotag=""
+    update=""
+
+    if [ "$tag" = "HEAD" ] ; then
+       cotag=""
+       uptag="-A"
+    elif [ "$tag" ] ; then
+       cotag="-r $tag"
+       uptag="-r $tag"
+    else
+       # silently skip if no tag was specified
+       return
+    fi
 
     if [ -d "$dir" ] ; then
-       echo "$progname: Updating $dir to -r $tag"
-       ( cd "$dir" && cvs up -r "$tag" )
+       echo "$progname: Updating $dir to $tag"
+       ( cd "$dir" && cvs up -dP $uptag )
     else
-       echo "$progname: Checking out $dir from -r $tag"
-       cvs co -r "$tag" -d "$dir" "$module"
+       echo "$progname: Checking out $dir from $tag"
+       cvs co -P $cotag -d "$dir" "$module"
+    fi
+    if [ $? != 0 ] ; then
+       error_modules="$dir $error_modules"
     fi
 }
 
-cvs_cmd build build "$buildtag"
-cvs_cmd portals portals "$portalstag"
-cvs_cmd lustre lustre-core "$lustretag"
+cvs_cmd build lustre-build "$buildtag"
+
+if [ -f build/buildcvs ] ; then
+    . build/buildcvs
+else
+    fatal 1 "build/buildcvs does not exist; not updating other modules."
+fi
+
+if [ "$error_modules" ] ; then
+    fatal 1 "There were errors checking out the following directories: $error_modules"
+fi